import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class bit_sum {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		try {
			while (!st.hasMoreTokens()) {
				String line = input.readLine();
				if (line == null) return false;
				st = new StringTokenizer(line);
			}
		} catch (IOException ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) {
		new bit_sum().run();
	}
	
	public static final int MOD = 1000000007;
	
	int get(int[] array, int idx) {
		return (idx < 0) ? 0 : array[idx];
	}

	void run() {
		int n = nextInt(), k = nextInt();
		char[] bits = nextToken().toCharArray();
		
		int[] carry0 = new int[k+1], carry1 = new int[k+1];
		int[] next0 = new int[k+1], next1 = new int[k+1];
		carry0[0] = 1;
		
		while (n-->0) {
			for (int i = 0; i <= k; ++i) {
				long n0, n1;
				if (bits[n] == '0') {
					n0 = (long) get(carry0,i) + get(carry1,i-1) + get(carry0,i-1);
					n1 = get(carry1,i);
				} else {
					n0 = get(carry0,i-1);
					n1 = (long) get(carry1,i) + get(carry0,i) + get(carry1,i-1);
				}
				next0[i] = (int) (n0 % MOD);
				next1[i] = (int) (n1 % MOD);
			}
			int[] tmp = carry0; carry0 = next0; next0 = tmp; tmp = carry1; carry1 = next1; next1 = tmp;
		}
		
		// ignore carry 1
		//System.out.println((carry0[k] + carry1[k]) % MOD);
		
		// count also carry 1
		System.out.println((get(carry0,k) + get(carry1,k-1)) % MOD);
	}
}
