#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;

#define MOD (1000000000+7)
ll d(ll s){return s%MOD;}
ll powermod (ll b, ll p){
    ll r = 1;
	b %= MOD;
    while (p > 0) {
        if (p & 1) r = (r*b)%MOD;
        p >>= 1;
        b = (b*b)%MOD;
    }
    return r;
}
ll modinv (ll b) {
	return powermod(b, MOD-2);
}
const int SIZE = 1007;
ll P[SIZE], I[SIZE];
void precomputeFactorial(ll n){
    P[0] = 1;
    for(int i=0; i<n; ++i) P[i+1] = d(P[i]*(i+1));
    I[n-1] = modinv(P[n-1]);
    for(int j=0; j<n-1; ++j) {
		ll i=n-2-j;
        I[i] = d(I[i+1] * (i+1));
    }
}
// p contains factorial of SIZE, i has its inverse
ll comb(ll x, ll y) {
    return d(d(P[x] * I[y]) * I[x - y]);
}

int main(){
    ll N,K;cin>>N>>K;
    precomputeFactorial(SIZE);
    cout<<comb(N,K)<<endl;

    return 0;
}

